/*
 * 开团配置
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class TeamConfigController : BaseController
    {
        public TeamConfigController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 开团配置列表

        /// <summary>
        /// 根据条件查询开团配置列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(TeamConfig data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            string Condition = "";
            
            if (!string.IsNullOrEmpty(Condition))
            { 
                Condition = Condition.TrimEnd(',');
                Condition = ", where: {" + Condition + "}";
            }
            ViewBag.Condition = Condition;
            return View();
        }

        #endregion

        #region 根据条件查询开团配置列表

        /// <summary>
        /// 开团配置列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(TeamConfig data, int page = 1, int limit = 30)
        {
            
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            
            
            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("TeamConfig", Fields, "Id desc", "0", page, limit, " and Status>-1");
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["OverlineStatusName"] = dic["OverlineStatus"].ToString() == "1" ? "是" : "否";

            }
            return Json(obj);
        }

        #endregion

        #region 增加开团配置

        /// <summary>
        /// 增加或修改开团配置信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            return View();
        }

        #endregion

        #region 增加开团配置

        /// <summary>
        /// 增加或修改开团配置信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(TeamConfig data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            Fields.Add("LimitBuddyNo", data.LimitBuddyNo); //限制人
Fields.Add("MinUserNum", data.MinUserNum); //最小队伍人数
Fields.Add("MaxUserNum", data.MaxUserNum); //最大队伍人数
Fields.Add("MinCycleNum", data.MinCycleNum); //最小周期天数
Fields.Add("MaxCycleNum", data.MaxCycleNum); //最大周期天数
Fields.Add("MinStartDayLimit", data.MinStartDayLimit); //最小间隔天数
Fields.Add("MaxStartDayLimit", data.MaxStartDayLimit); //最大间隔天数
Fields.Add("OverlineStatus", data.OverlineStatus); //是否允许跨顶级线报名
Fields.Add("BlacklistCycle", data.BlacklistCycle); //黑名单周期
Fields.Add("EnterEndMin", data.EnterEndMin); //活动时间差
Fields.Add("Remark", data.Remark); //备注

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("TeamConfig", Fields, 0);
            AddSysLog(data.Id.ToString(), "TeamConfig", "add");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 修改开团配置

        /// <summary>
        /// 增加或修改开团配置信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            TeamConfig editData = db.TeamConfig.FirstOrDefault(m => m.Id == Id) ?? new TeamConfig();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改开团配置

        /// <summary>
        /// 增加或修改开团配置信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(TeamConfig data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            Fields.Add("LimitBuddyNo", data.LimitBuddyNo); //限制人
Fields.Add("MinUserNum", data.MinUserNum); //最小队伍人数
Fields.Add("MaxUserNum", data.MaxUserNum); //最大队伍人数
Fields.Add("MinCycleNum", data.MinCycleNum); //最小周期天数
Fields.Add("MaxCycleNum", data.MaxCycleNum); //最大周期天数
Fields.Add("MinStartDayLimit", data.MinStartDayLimit); //最小间隔天数
Fields.Add("MaxStartDayLimit", data.MaxStartDayLimit); //最大间隔天数
Fields.Add("OverlineStatus", data.OverlineStatus); //是否允许跨顶级线报名
Fields.Add("BlacklistCycle", data.BlacklistCycle); //黑名单周期
Fields.Add("EnterEndMin", data.EnterEndMin); //活动时间差
Fields.Add("Remark", data.Remark); //备注

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("TeamConfig", Fields, data.Id);
            AddSysLog(data.Id.ToString(),"TeamConfig","update");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 删除开团配置信息

        /// <summary>
        /// 删除开团配置信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"TeamConfig","del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("TeamConfig", Fields, id);
            }
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"TeamConfig","open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("TeamConfig", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"TeamConfig","close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("TeamConfig", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("TeamConfig", Sort, Id);
            
            AddSysLog(Id.ToString(), "TeamConfig", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count;i++ )
            {
                JsonData dr = list[i];
                
                db.TeamConfig.Add(new TeamConfig()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,
                    
                });
                db.SaveChanges();
            }
            AddSysLog("0", "TeamConfig", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(TeamConfig data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            
            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("TeamConfig", Fields, "Id desc", "0", 1, 20000, "", "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["OverlineStatusName"] = dic["OverlineStatus"].ToString() == "1" ? "是" : "否";

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            
            result.Add("Fields", ReturnFields);
            AddSysLog("0", "TeamConfig", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
